public class Weather {
  String url;
  public Weather( String url ) {
    this.url = url;
  }
  
  void draw() {
    String[] data = loadStrings( url );
    String[] w = data[0].split("\\|");
    w[3] = w[3].toLowerCase();
    fill( 0, 64 );
    rect( 10, 210, 100, 80 );
    fill( color( 128, 255, 128 ));
    textAlign(CENTER);

    textFont( font, 48 );
    text( w[0], 60, 260 );
    textFont( font, 16 );
    text( w[1] + "/" + ( w[2].equals("") ? "--" : w[2] ) , 60, 280 );
  
    
    if (w[3].indexOf("cloud") != -1) {
      for ( int i = 0; i < 5; i++ ) {
        cloud( int(random( width - 100 ) + 50), int(random( 50 ) + 50), int( random( 50 ) + 50 ));
      } 
    } else if (w[3].indexOf("sun") != -1) {
      sun( 50, 50, 50 );
    } else if (w[3].indexOf("wind") != -1) {
      wind();
    } else if (w[3].indexOf("rain") != -1) {
      rain(width/2, 100, width, 200);   
    } else if (w[3].indexOf("snow") != -1) {
      snow(width/2, 100, width, 200);
    } else if (w[3].indexOf("fog") != -1) {
      fog();
    }
  }

  void fog() {
    noFill();
    strokeWeight(2);
    stroke(255);
    for( int i = 0; i < 100; i ++ ) {
      stroke(255, map( i, 100, 0, 0, 255));
      line( 0, height - 100 - i, width, height - 100 - i );
    }
  }

  void cloud( int x, int y, int w ) {
    int u = w/6;
    // this is a bit of a hack to prevent floating point rounding errors
    int u15 = int(u * 1.5);
    int u25 = int(u * 2.5);
    fill(255, 200);

    noStroke();
    rect( x - 4 * u , y-u15, 8 * u, 3*u );

    stroke(0);
    strokeWeight(2);

    arc( x - 4 * u, y, 3 * u, 3 * u, PI/2 , PI * 1.5);
    arc( x + 4 * u, y, 3 * u, 3 * u, PI * 1.5, PI/2 );

    arc( x - u15, y - u15, 5 * u, 5 * u, PI, 0 );
    arc( x + u25, y - u15, 3 * u, 3 * u, PI, 0 );

    line( x - 4 * u, y + u15, x + 4 * u, y + u15 );
  }

  void rain(int x, int y, int w, int h) {
    randomSeed(1);
  
    for( int i = 0; i < max( w, h) / 10; i++ ) {
      pushMatrix();
      translate( x + ( random(w) - w/2), y +( random(h) - h/2));
      stroke( 128,128,255);
      fill( 128,128,255);
      ellipse( 0,0,10,10);
      beginShape();
      vertex( -5, 0 );
      vertex( 0, -20 );
      vertex( 5, 0 );
      endShape();
      popMatrix();
    }
  }


  void snow(int x, int y, int w, int h) {
    randomSeed(1);
    strokeWeight(4);
    stroke(255, 128);
    for( int i = 0; i < max(w,h) / 10; i++ ) {
      pushMatrix();
      translate( x + ( random(w) - w/2), y +( random(h) - h/2 - 10));
      line( -10, 0,  10, 0 );
      line( 0, -10 , 0,  10 );
      rotate( radians( 45 ));
      line( - 10, 0,  10, 0 );
      line( 0, -10 , 0,  10 );
      popMatrix();
    }
  }

  void sun( int x, int y, int s) {
    stroke( 255, 255, 0 );
    fill( 255, 200, 0 );
    strokeWeight( 4 );

    pushMatrix();
    translate(x, y);
    for ( int i = 0; i < 12; i++) {
      line(0, 0, s, 0);
      rotate( TWO_PI/12 );
    }
    popMatrix();
    ellipse( x,y,s, s );
  }

  void wind() {
    pushMatrix();
    translate( 100, -30 );
    noFill();
    strokeWeight(2);
    stroke(255);
    line(10, 145, 210, 145);
    arc( 210, 125, 40, 40, PI, PI/2 );
    line(10, 150, 250, 150);
    arc( 250, 140, 20, 20, PI, PI/2 );
    line(10, 155, 230, 155);
    arc( 230, 170, 30, 30, TWO_PI - PI/2 , PI );
    popMatrix();
  }
}
