require "serialport.so"
require 'webrick';
require 'caldav';
include WEBrick

require 'rubygems'
gem 'rubyweather'
require 'weather/service'



CALENDAR = [
    Caldav.new( "calenderserver", 80, '/path/to/calender1', 'username', 'password'),
    Caldav.new( "calenderserver", 80, '/path/to/calender2', 'username', 'password'),
]

SERIALPORT="/dev/ttyUSB0"

s =  HTTPServer.new( :Port => 2000 )


class IcalServlet < HTTPServlet::AbstractServlet 

    def do_GET( req, res ) 
    
        start = DateTime.now - 7
        stop =  DateTime.now + 8
        startstr = start.strftime "%Y%m%dT000000"
        stopstr  = stop.strftime "%Y%m%dT000000"

        body = """BEGIN:VCALENDAR
PRODID:icalproxy
VERSION:2.0

BEGIN:VTIMEZONE
TZID:/Europe/Vienna
X-LIC-LOCATION:Europe/Vienna
BEGIN:DAYLIGHT
TZOFFSETFROM:+0100
TZOFFSETTO:+0200
TZNAME:CEST
DTSTART:19700329T020000
RRULE:FREQ=YEARLY;INTERVAL=1;BYDAY=-1SU;BYMONTH=3
END:DAYLIGHT
BEGIN:STANDARD
TZOFFSETFROM:+0200
TZOFFSETTO:+0100
TZNAME:CET
DTSTART:19701025T030000
RRULE:FREQ=YEARLY;INTERVAL=1;BYDAY=-1SU;BYMONTH=10
END:STANDARD
END:VTIMEZONE

""" 
      
        CALENDAR.each{ |cal| 
            data = cal.report startstr, stopstr
            puts data.length
            data.each{ |event|
                event.dtstart = event.dtstart + "T000000" if event.dtstart.length == 8
                event.dtend = event.dtend + "T000000" if event.dtend.length == 8
                body += 
"""
BEGIN:VEVENT
SUMMARY: #####
UID:#{event.uid}
DTSTART;TZID=Europe/Vienna:#{event.dtstart}
DTEND;TZID=Europe/Vienna:#{event.dtend}
END:VEVENT
"""

            }
       
        }
        
        body += "END:VCALENDAR"

        
       res.body = body 
       res['Content-Type'] = "text/calendar"

    end
end

class WeatherServlet < HTTPServlet::AbstractServlet 
    def do_GET( req, res ) 


        service = Weather::Service.new
        service.imperial = false
        forecast = service.fetch_forecast( "AUXX0025", 2 )

        day = forecast.current
        body =  "#{day.temp}|#{forecast.day(0).lo}|#{forecast.day(0).hi}|#{day.outlook}\n"
        res.body = body 
        res['Content-Type'] = "text/plain"
    end
end

class IndoorServlet < HTTPServlet::AbstractServlet 
    def do_GET( req, res ) 
        body = "--.--"
        begin
            sp = SerialPort.new( SERIALPORT, 9600, 8, 1, SerialPort::NONE)
            sp.write( "C" )
            body = sp.readline()
            sp.close    
        rescue
            puts "cant open serial port"
        end

        res.body = body 
        res['Content-Type'] = "text/plain"
    end
end

s.mount( "/ical", IcalServlet )
s.mount( "/weather", WeatherServlet )
s.mount( "/indoor", IndoorServlet )

trap("INT"){ s.shutdown }
s.start
